package blanco.nlpack.generator.task;

import java.io.IOException;

import blanco.nlpack.generator.csv.io.BlancoCsvIOException;
import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorMergeResultDetailProcessInput;
import blanco.nlpack.generator.util.BlancoNLpackGeneratorMergeResultDetail;

public class BlancoNLpackGeneratorMergeResultDetailProcessImpl implements
        BlancoNLpackGeneratorMergeResultDetailProcess {

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     * 
     * @param input
     *            処理の入力パラメータ。
     * @return 処理の実行結果。
     * @throws IOException
     *             入出力例外が発生した場合。
     * @throws IllegalArgumentException
     *             入力値に不正が見つかった場合。
     */
    public int execute(
            final BlancoNLpackGeneratorMergeResultDetailProcessInput input)
            throws IOException, IllegalArgumentException {
        try {
            new BlancoNLpackGeneratorMergeResultDetail().process(input);
        } catch (BlancoCsvIOException e) {
            if (input.getVerbose()) {
                e.printStackTrace();
            }
            throw new IOException("CSV入出力例外が発生: " + e.toString());
        }
        return BlancoNLpackGeneratorMergeResultDetailBatchProcess.END_SUCCESS;
    }

    /**
     * {@inheritDoc}
     */
    public boolean progress(final String argProgressMessage) {
        System.out.println(argProgressMessage);
        return false;
    }
}
